<?php

function CheckAbilityOfInstallation()
{
  $result['Success'] = 1;
  $result['ErrorMessage'] = '!';

  // check if all files are writeable
  $files = file($GLOBALS['TMP_FOLDER']."files.txt");
  foreach ($files as $file)
  {
     $file = $GLOBALS['DOCUMENT_ROOT'].rtrim($file);
     if (file_exists($file))
     {
        if (!is_writable($file)) // file is not writable
        {
           $result['ErrorMessage'] = "<b>         netcat.</b><br><small>($file   )</small>";
           $result['Success'] = 0;
        }
     }
     else // check dir
     {
        $dirname = dirname($file);
        // find the nearest existing parent directory
        while (!file_exists($dirname))
        {
           $dirname = preg_replace("!/[^/]+$!", "", $dirname);
           if ($dirname=="$GLOBALS[DOCUMENT_ROOT]/netcat") break;
        }

        if (!is_writable($dirname)) // directory is not writable
        {
           $result['ErrorMessage'] = "<b>      $GLOBALS[DOCUMENT_ROOT]/netcat   .</b><br><small>($dirname   )</small>";
           $result['Success'] = 0;
        }
     }
  }


  return $result;
}

function InstallPatch()
{
  global $DOCUMENT_ROOT, $TMP_FOLDER;

  $result['Success'] = 1;
  $result['ErrorMessage'] = '!';

  // fcking windows tar
  rename($TMP_FOLDER."/netcat/require/lib/http", $TMP_FOLDER."/netcat/require/lib/HTTP");

  // vars.inc

  $filename=$DOCUMENT_ROOT."/netcat/vars.inc.php";

  $fr = fopen($filename, 'r') or die("error open file");
  $fcontent = fread($fr, filesize($filename));
  $fw = fopen($filename, 'r+') or die("error open file");

//________
$newcontent=str_replace('@ini_set("session.use_trans_sid","1");','@ini_set("session.use_trans_sid","0");',$fcontent);
//________
$newcontent=preg_replace('/@ini_set\("session\.use_cookies",.+?\);/','@ini_set("session.use_cookies","1");
@ini_set("session.use_only_cookies","1");
@ini_set("url_rewriter.tags", ""); // to disable trans_sid on PHP < 5.0
if ($_SERVER["HTTP_HOST"] != "localhost") @ini_set("session.cookie_domain", $_SERVER["HTTP_HOST"]);
;',$newcontent);
//________
$newcontent=str_replace('$DOC_DOMAIN = \'docs.netcat.ru/23\';',
'$DOC_DOMAIN = \'docs.netcat.ru/24\';

// add require/lib folder (PEAR libraries) to the include_path
$path_delimiter = substr_count($_ENV["OS"],"Windows") ? ";" : ":";
ini_set("include_path", ini_get("include_path")."$path_delimiter{$INCLUDE_FOLDER}lib/");
unset($path_delimiter);

', $newcontent);
//_________

  fputs($fw,$newcontent);
  fclose($fr);
  fclose($fw);


  // update classificators
  $res = mysql_query("SELECT Table_Name FROM Classificator");
  while (list($table)=mysql_fetch_row($res))
  {
     mysql_query("ALTER TABLE `Classificator_$table` ADD `{$table}_Priority` INT")
        or print "SQL Error (Classificator_$table)<br>";
  }

  // Patch User
  if (!mysql_num_rows(mysql_query("SHOW FIELDS FROM User LIKE 'Login'")))
  {
     mysql_query("ALTER TABLE User ADD `Login` varchar(255) NOT NULL default ''")
        or print "SQL Error (User/Login)<br>";
     mysql_query("INSERT INTO `Field` (`Class_ID`, `Field_Name`, `Description`, `TypeOfData_ID`, `Format`, `NotNull`, `Priority`, `DoSearch`, `DefaultState`, `Inheritance`, `System_Table_ID`, `TypeOfEdit_ID`) VALUES (0, 'Login', '', 1, '', 1, 1, 1, '', 0, 3, 1)")
        or print "SQL Error (User/Login, 2)<br>";
  }

  // message about banner module
  if (mysql_result(mysql_query("SELECT COUNT(*) FROM Module WHERE Keyword='banner'"),0,0))
  {
     mysql_query("INSERT INTO `SystemMessage` ( `Date` , `Description` , `Checked` , `Message` )
        VALUES ( NOW( ) ,
        ' &laquo; &raquo;', '0',
        '<p>  NetCat   2.4    &laquo; &raquo;.           <a href=''mailto:support@netcat.ru''>support@netcat.ru</a>.       NetCat   ,    .</p>')");
  }

  return $result;
}

?>