<?
/* $Id: function.inc.php,v 1.3 2006/06/15 08:02:42 volodya Exp $ */

##############################################
#     Message
##############################################
function ColumnInMessage ($FieldID, $type, $db)
{
    global $db;

    # $type description:
    # 1 - add
    # 2 - modify
    # 3 - drop

    $SelectField = $db->get_row("SELECT Class_ID,Field_Name,TypeOfData_ID,NotNull,DoSearch,DefaultState FROM Field WHERE Field_ID=".$FieldID) ;

    switch ($type)
    {
        case 1: $oper = "add"; break;
        case 2: $oper = "modify"; break;
        case 3: $oper = "drop"; break;
    }

    $db->hide_errors();
    $db->query("ALTER TABLE Message".$SelectField->Class_ID." DROP INDEX ".$SelectField->Field_Name);
    $db->show_errors();

    $alter = "ALTER TABLE Message".$SelectField->Class_ID." ".$oper." ".$SelectField->Field_Name;

    if ($type==3)
    {
        $AlterResult = $db->query($alter);
        return;
    }

    $alter .= " ";

    switch ($SelectField->TypeOfData_ID)
    {
        case 1: $alter .= "char(255)"; break;
        case 2: $alter .= "int"; break;
        case 3: $alter .= "text"; break;
        case 4: $alter .= "int"; break;
        case 5: $alter .= "tinyint"; break;
        case 6: $alter .= "char(255)"; break;
        case 7: $alter .= "double"; break;
        case 8: $alter .= "datetime"; break;
    }

    if ($SelectField->DefaultState!="" && $SelectField->TypeOfData_ID!=3)
    $alter.= " NOT NULL DEFAULT '$SelectField->DefaultState'";
    else
    if ($SelectField->NotNull)
    $alter.= " NOT NULL";
    else
    $alter.= " NULL";

    $AlterResult = $db->query($alter);

    if ($SelectField->DoSearch && $SelectField->TypeOfData_ID!=3)
    $db->query("ALTER TABLE Message".$SelectField->Class_ID." ADD INDEX (".$SelectField->Field_Name.")");

}

##############################################
#   
##############################################
function FieldList ($ClassID)
{
    global $db;
    $ClassID+=0;
    if (!$ClassID)
    {
        return;
    }

    $Result = $db->get_results("SELECT Field_ID, Field_Name, Description, Priority FROM Field WHERE Class_ID=".$ClassID." ORDER BY Priority");

    if ($countFields=$db->num_rows)
    {

 		?>

 		<form method=post action="index.php">
 		<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td bgcolor=cccccc>
        <table border=0 cellpadding=4 cellspacing=1 width=100%>
        <tr>
        <td bgcolor=eeeeee><font size=-2><b>ID</td>
        <td bgcolor=eeeeee width=40%><font size=-2><b><?=CONTROL_FIELD_LIST_NAME?></td>
        <td bgcolor=eeeeee width=40%><font size=-2><b><?=CONTROL_FIELD_LIST_DESCRIPTION?></td>
        <td bgcolor=eeeeee align=center><img width=16 height=16 src=../images/prior.gif alt='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_PRIORITY?>'></td>
        <td bgcolor=eeeeee align=center><img src=../images/kill.gif width=18 height=18 alt='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWCATALOGUELIST_DELETE?>'></td>
        </tr>

 		<?

 		foreach ( $Result as $Row )
 		{
 		    $Array[0] = $Row->Field_ID;
 		    $Array[1] = $Row->Field_Name;
 		    $Array[2] = $Row->Description;
 		    $Array[3] = $Row->Priority;
 		    print "<tr>";
 		    print "<td bgcolor=white><font size=-2><b>".$Array[0]."</td>";
 		    print "<td bgcolor=white><a href=\"index.php?phase=4&FieldID=".$Array[0]."\">".$Array[1]."</a></td>";
 		    print "<td bgcolor=white><font size=-2>".$Array[2]."</td>";
 		    print "<td align=center bgcolor=white><input type=text name=Priority".$Array[0]." value='".($Array[3]?$Array[3]:0)."' size=3 class=s maxlength=5></td>";
 		    print "<td align=center bgcolor=white><INPUT TYPE=CHECKBOX NAME=\"Delete".$Array[0]."\" VALUE=".$Array[0]."></td>\n";
 		    print "</tr>";
 		}

 		print "<INPUT TYPE=HIDDEN NAME='ClassID' VALUE='".$ClassID."'>\n";

 		?>
        </table>
        </td></tr></table><br>
		<?
    }
    else
    {
        echo CONTROL_FIELD_LIST_NONE."<br><br>";
    }
	?>
    <table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td><a href="index.php?phase=2&ClassID=<? print $ClassID; ?>"><b><?=CONTROL_FIELD_LIST_ADD?></b></a></td>
	<?
	if ($countFields)
	{
		?>
        <td align=right><input class=s type=reset value='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CANCEL?>'> <input type=submit class=s value='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE?>'></td>
		<?
	}
	?>
    </tr></table>
	<?
	if ($countFields)
	{
		?>
        <input type=hidden name=phase VALUE=6>
        </form>
 		<?
	}
}

#########################################
#        
#########################################

function FieldForm ($FieldID, $ClassID)
{
    global $db;

    if ($FieldID)
    {
        $Array = $db->get_row("SELECT Field_Name, Description, TypeOfData_ID, Format, NotNull, Priority, DoSearch, DefaultState, TypeOfEdit_ID FROM Field WHERE Field_ID=".$FieldID,ARRAY_A) ;
    }
    else
    {
        if ($Priority=="")
        {
            $res = $db->get_var("SELECT (Priority+1) FROM Field WHERE Class_ID=".$ClassID." ORDER BY Priority DESC LIMIT 1");
            if (!is_null($res))
            {
                $Priority = $res;
            }
            $Array["Priority"] = $Priority;
        }
    }

    print "<FORM METHOD=POST ACTION=index.php><font color=gray>";

    if ($FieldID)
    {
        print CONTROL_FIELD_LIST_NAME.": <b>".$Array["Field_Name"]."</b><br><br>";
    }
    else
    {
        print CONTROL_FIELD_LIST_NAMELAT.":<br><INPUT TYPE=TEXT NAME=FieldName SIZE=50 MAXLENGTH=64 value='".htmlspecialchars($Array["Field_Name"])."'><br><br>";
    }

    print CONTROL_FIELD_LIST_DESCRIPTION.":<br><INPUT TYPE=TEXT NAME=Description SIZE=50 MAXLENGTH=64 value='".htmlspecialchars($Array["Description"])."'><br><br>";

    print CONTROL_FIELD_ONE_FTYPE.":<br><SELECT NAME=TypeOfDataID>";
    print "<OPTION ".($Array["TypeOfData_ID"]==1?"selected":"")." VALUE=1>1: ".CLASSIFICATOR_TYPEOFDATA_STRING;
    print "<OPTION ".($Array["TypeOfData_ID"]==2?"selected":"")." VALUE=2>2: ".CLASSIFICATOR_TYPEOFDATA_INTEGER;
    print "<OPTION ".($Array["TypeOfData_ID"]==3?"selected":"")." VALUE=3>3: ".CLASSIFICATOR_TYPEOFDATA_TEXTBOX;
    print "<OPTION ".($Array["TypeOfData_ID"]==4?"selected":"")." VALUE=4>4: ".CLASSIFICATOR_TYPEOFDATA_LIST;
    print "<OPTION ".($Array["TypeOfData_ID"]==5?"selected":"")." VALUE=5>5: ".CLASSIFICATOR_TYPEOFDATA_BOOLEAN;
    print "<OPTION ".($Array["TypeOfData_ID"]==6?"selected":"")." VALUE=6>6: ".CLASSIFICATOR_TYPEOFDATA_FILE;
    print "<OPTION ".($Array["TypeOfData_ID"]==7?"selected":"")." VALUE=7>7: ".CLASSIFICATOR_TYPEOFDATA_FLOAT;
    print "<OPTION ".($Array["TypeOfData_ID"]==8?"selected":"")." VALUE=8>8: ".CLASSIFICATOR_TYPEOFDATA_DATETIME;
    print "</SELECT><br><br>";

    print CONTROL_FIELD_ONE_FORMAT.":<br><INPUT TYPE=TEXT NAME=Format SIZE=50 MAXLENGTH=255 value='".htmlspecialchars($Array["Format"])."'><br><br>";

    print "<input id=notn type=checkbox ".($Array["NotNull"]?"checked":"")." name=NotNull value=1> <label for=notn>".CONTROL_FIELD_ONE_MUSTBE."</label><br>";
    print "<input id=dosr type=checkbox ".($Array["DoSearch"]?"checked":"")." name=DoSearch value=1> <label for=dosr>".CONTROL_FIELD_ONE_INDEX."</label><br><br>";

    print CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_PRIORITY.": <INPUT TYPE=TEXT NAME=Priority SIZE=3 MAXLENGTH=5 value='".($Array["Priority"]+0)."'><br><br>";

    print CONTROL_FIELD_ONE_DEFAULT."*:<br>";
    print "<INPUT TYPE=TEXT NAME=DefaultState SIZE=50 MAXLENGTH=255 value='".htmlspecialchars($Array["DefaultState"])."'><br>* ".CONTROL_FIELD_ONE_DEFAULT_NOTE.".<br><br>";

    print "<table border=0 cellpadding=6 cellspacing=0 width=100%>";

    print "<TR><TD valign=top width=30%><font color=gray>".CONTROL_FIELD_ONE_ACCESS.":</td><td>";

    if ($Array["TypeOfEdit_ID"]=="")
    {
        $Array["TypeOfEdit_ID"] = 1;
    }

    echo "<input type=radio name=TypeOfEdit_ID ";
    if ($Array["TypeOfEdit_ID"] == 1)
    {
        print "checked ";
    }
    print "VALUE=1 id=mod1> <label for=mod1>".CLASSIFICATOR_TYPEOFEDIT_ALL."</label><br>";

    echo "<input type=radio name=TypeOfEdit_ID ";
    if ($Array["TypeOfEdit_ID"] == 2)
    {
        print "checked ";
    }
    print "VALUE=2 id=mod2> <label for=mod2>".CLASSIFICATOR_TYPEOFDATA_ADMINS."</label><br>";

    echo "<input type=radio name=TypeOfEdit_ID ";
    if ($Array["TypeOfEdit_ID"] == 3)
    {
        print "checked ";
    }
    print "VALUE=3 id=mod3> <label for=mod3>".CLASSIFICATOR_TYPEOFDATA_NOONE."</label><br>";

    print "</SELECT></TD></TR>\n\n";
    print "</table>";

    ?>
    <hr size=1 color=cccccc><div align=right>
    <?

    if (!$FieldID)
    {
        echo "<input class=s type=submit value='".CONTROL_FIELD_LIST_ADD."'>";
    }
    else
    {
        echo "<input class=s type=reset value='".CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_CANCEL."'> <input class=s type=submit value='".CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE."'>";
    }

    ?>
    </div>
    <?

    if ($ClassID)
    {
        print "<INPUT TYPE=HIDDEN NAME=ClassID VALUE=".$ClassID.">";
        print "<input type=hidden name=phase value=3>";
    }
    else
    {
        print "<INPUT TYPE=HIDDEN NAME=FieldID VALUE=".$FieldID.">";
        print "<input type=hidden name=phase value=5>";
    }

    print "</FORM>";

}

#######################################################
#        
#################################################
function FieldCompleted ()
{
    global $db,$FieldID,$ClassID,$FieldName,$Description,$TypeOfDataID,$TypeOfEdit_ID,$Format,$NotNull,$Priority,$DoSearch,$DefaultState;

    $NotNull += 0;
    $DoSearch += 0;
    $Priority += 0;

    //       
    if (!$FieldID)
    {
        require_once("$GLOBALS[ADMIN_FOLDER]field/reserved.inc.php");
        
        // ,    ,  
        if ( $SelectResult = $db->get_results("show fields from Message".$ClassID." like '".$FieldName."'") )
        {
            return false;
        }
        else if (preg_match('/\\b\\d+\\b/', str_replace(" ","",$FieldName)))
        {
            return false;
        }
        // check for reserved sql words
        else if (nc_is_mysql_keyword($FieldName))
        {
           return false;  
        }
        else
        {
            if ($inserted = $db->query("insert into Field (Class_ID,Field_Name,Description,TypeOfData_ID,Format,NotNull,Priority,DoSearch,DefaultState,TypeOfEdit_ID) values (".$ClassID.",'".$FieldName."','".$Description."',".$TypeOfDataID.",'".$Format."',".$NotNull.",".$Priority.",".$DoSearch.",'".$DefaultState."','".$TypeOfEdit_ID."')"))
            {
                $CurrentFieldID = $db->insert_id ;
                ColumnInMessage ($CurrentFieldID, 1, $db);
            }
        }
    }
    //   ,       
    else
    {
        if ($updated = $db->query("update Field set Description='".$Description."',TypeOfData_ID=".$TypeOfDataID.",Format='".$Format."',NotNull=".$NotNull.",Priority=".$Priority.",DoSearch=".$DoSearch.",DefaultState='".$DefaultState."',TypeOfEdit_ID='".$TypeOfEdit_ID."' where Field_ID=".$FieldID))
        {
            ColumnInMessage ($FieldID, 2, $db);
        }
    }

    return true;
}

######################################################
#   ,     
######################################################

function UpdateFieldPriority ()
{
    global $db;

    reset($_POST);
    while (list($key, $val) = each($_POST)) {
        if (substr($key,0,8)=="Priority") {
            $field_id = substr($key,8,strlen($key)-8)+0;
            $val += 0;

            $db->query("UPDATE Field SET Priority=".$val." WHERE Field_ID=".$field_id);
        }
    }
}

##########################################
#  ,     
##########################################

function DeleteFields ()
{
    global $db;

    reset($_POST);
    while (list($key, $val) = each($_POST)) {
        if (substr($key,0,6)=="Delete" && $val) {
            $val += 0;

            ColumnInMessage ($val, 3, $db);
            $db->query("DELETE FROM Field WHERE Field_ID=".$val);
        }
    }
}

###############################################################################

?>