<?
###############################################################################

function IsCatalogueExist ($CatalogueID)
{
    global $db;

    if ($db->get_results(" select Catalogue_ID from Catalogue where Catalogue_ID='".$CatalogueID."'"))
    return 1;
    else
    return 0;

}

###############################################################################

function GetDomainBySubdivisionID ($SubdivisionID)
{
    global $db;

    $res = $db->get_var("select Domain from Catalogue,Subdivision where Subdivision_ID='".$SubdivisionID."' and Subdivision.Catalogue_ID=Catalogue.Catalogue_ID");
    return $res;
}

###############################################################################

function GetDomainByCatalogueID ($CatalogueID)
{
    global $db;

    $res = $db->get_var("select Domain from Catalogue where Catalogue_ID='".$CatalogueID."'");

    return $res;
}


###############################################################################

function GetGroupBySubdivisionID ($SubdivisionID)
{
    global $db;

    $res = $db->get_var("select Groups_ID from Catalogue,Subdivision where Subdivision_ID='".$SubdivisionID."' and Subdivision.Catalogue_ID=Catalogue.Catalogue_ID");

    return $res;
}

###############################################################################

function GetGroupByCatalogueID ($CatalogueID)
{
    global $db;

    $res = $db->get_var("select Groups_ID from Catalogue where Catalogue_ID='".$CatalogueID."'");

    return $res;
}

###############################################################################

function CascadeDeleteCatalogue ($CatalogueID)
{
    global $db;

    $LockTables = "lock tables Catalogue WRITE, Subdivision WRITE, Sub_Class WRITE, Log WRITE, Permission WRITE";
    $DeleteLog = "delete from Log where Catalogue_ID='".$CatalogueID."'";
    $DeleteCatalogue = "delete from Catalogue where Catalogue_ID='".$CatalogueID."'";
    $DeleteSubdivision = "delete from Subdivision where Catalogue_ID='".$CatalogueID."'";
    $DeleteSubClass = "delete from Sub_Class where Catalogue_ID='".$CatalogueID."'";
    $DeletePermission = "delete from Permission where AdminType='".CATALOGUE_ADMIN."' and Catalogue_ID='".$CatalogueID."'";

    $AddLockTables = "";
    $SubClassResult = $db->get_results("select Sub_Class_ID, Class_ID from Sub_Class where Catalogue_ID='".$CatalogueID."'",ARRAY_N);
    foreach ($SubClassResult as $SubClassArray)
    {
        $AddLockTables .= ", Message".$SubClassArray[1]." WRITE";
        $SubClassID [] = $SubClassArray[0];
        $SubClassID [] = $SubClassArray[1];
    }

    $LockResult = $db->query($LockTables.$AddLockTables);

    for ($i=0; $i<count($SubClassID); $i+=2)
    {
        $db->query("delete from Message".$CatClassID[$i+1]." where Sub_Class_ID='".$CatClassID[$i]."'");
        $db->query("delete from Message".$CatClassID[$i+1]." where Parent_Message_ID='".$CatClassID[$i]."'");
    }

    $SelectSubdivision = "select Subdivision_ID from Subdivision where Catalogue_ID='".$CatalogueID."'";
    $SubResult = $db->get_results("select Subdivision_ID from Subdivision where Catalogue_ID='".$CatalogueID."'",ARRAY_N);
    foreach ($SubResult as $SubArray)
    {
        DeleteFromPermission ($SubArray[0]);
    }

    $db->query($DeleteLog);
    $db->query($DeleteSubClass);
    $db->query($DeleteSubdivision);
    $db->query($DeleteCatalogue);
    $db->query($DeletePermission);

    $UnlockResult = $db->query("unlock tables");
}

###############################################################################

function HighLevelChildrenNumber ($CatalogueID)
{
    global $db;

    $res = $db->get_var("select count(Subdivision_ID) from Subdivision where Parent_Sub_ID=0 and Catalogue_ID=".$CatalogueID);
    return $Array[0];
}

###############################################################################

function IsAllowedDomain ($Domain, $CatalogueID)
{
    global $db;

    if ($db->get_results("select Domain from Catalogue where Domain='".$Domain."' and Catalogue_ID<>'".$CatalogueID."'"))
    return 1;
    else
    return 0;
}

###############################################################################

?>